/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.cortesias;

import com.rjconsultores.ventaboletos.entidad.TipoCortesia;
import com.rjconsultores.ventaboletos.entidad.TipoCortesiaDescuento;
import com.rjconsultores.ventaboletos.service.TipoCortesiaDescuentoService;
import com.rjconsultores.ventaboletos.service.TipoCortesiaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoCortesiaD;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Paging;

/**
 *
 * @author Shiro
 */
@Controller("busquedaTipoCortesiaDController")
@Scope("prototype")
public class BusquedaTipoCortesiaDController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<TipoCortesiaDescuento> plwTipoCortesiaD;
    @Autowired
    private TipoCortesiaService tipoCortesiaService;
    @Autowired
    private TipoCortesiaDescuentoService tipoCortesiaDescuentoService;
    private MyListbox tipoCortesiaDList;
    private Paging pagingTipoCortesiaD;
    private Combobox cmbTipoCortesia;
    private List<TipoCortesia> tipoCortesiaList;

    public MyListbox getTipoCortesiaDList() {
        return tipoCortesiaDList;
    }

    public void setTipoCortesiaDList(MyListbox tipoCortesiaDList) {
        this.tipoCortesiaDList = tipoCortesiaDList;
    }

    public Paging getPagingTipoCortesiaD() {
        return pagingTipoCortesiaD;
    }

    public void setPagingTipoCortesiaD(Paging pagingTipoCortesiaD) {
        this.pagingTipoCortesiaD = pagingTipoCortesiaD;
    }

    public PagedListWrapper<TipoCortesiaDescuento> getPlwTipoCortesiaD() {
        return plwTipoCortesiaD;
    }

    public void setPlwTipoCortesiaD(PagedListWrapper<TipoCortesiaDescuento> plwTipoCortesiaD) {
        this.plwTipoCortesiaD = plwTipoCortesiaD;
    }

    public Combobox getCmbTipoCortesia() {
        return cmbTipoCortesia;
    }

    public void setCmbTipoCortesia(Combobox cmbTipoCortesia) {
        this.cmbTipoCortesia = cmbTipoCortesia;
    }

    public List<TipoCortesia> getTipoCortesiaList() {
        return tipoCortesiaList;
    }

    public void setTipoCortesiaList(List<TipoCortesia> tipoCortesiaList) {
        this.tipoCortesiaList = tipoCortesiaList;
    }

    public TipoCortesiaService getTipoCortesiaService() {
        return tipoCortesiaService;
    }

    public void setTipoCortesiaService(TipoCortesiaService tipoCortesiaService) {
        this.tipoCortesiaService = tipoCortesiaService;
    }

    public TipoCortesiaDescuentoService getTipoCortesiaDescuentoService() {
        return tipoCortesiaDescuentoService;
    }

    public void setTipoCortesiaDescuentoService(TipoCortesiaDescuentoService tipoCortesiaDescuentoService) {
        this.tipoCortesiaDescuentoService = tipoCortesiaDescuentoService;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verTipoCortesiaD(new TipoCortesiaDescuento());

    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        tipoCortesiaList = tipoCortesiaService.obtenerTodos();
        super.doAfterCompose(comp);

        tipoCortesiaDList.setItemRenderer(new RenderTipoCortesiaD());

        tipoCortesiaDList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TipoCortesiaDescuento tcd = (TipoCortesiaDescuento) tipoCortesiaDList.getSelected();
                verTipoCortesiaD(tcd);
            }
        });

        refreshLista();
    }

    private void verTipoCortesiaD(TipoCortesiaDescuento tcd) {
        if (tcd == null) {
            return;
        }

        Map args = new HashMap();
        args.put("tipoCortesiaD", tcd);
        args.put("tipoCortesiaDList", tipoCortesiaDList);

        openWindow("/gui/cortesias/editarTipoCortesiaD.zul",
                Labels.getLabel("editarTipoCortesiaDController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<TipoCortesiaDescuento> claseServicioBusqueda =
                new HibernateSearchObject<TipoCortesiaDescuento>(TipoCortesiaDescuento.class, pagingTipoCortesiaD.getPageSize());

        claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);
        TipoCortesia tipoCortesia = (TipoCortesia) (cmbTipoCortesia.getSelectedItem() != null ? cmbTipoCortesia.getSelectedItem().getValue() : null);
        if (tipoCortesia != null) {
            claseServicioBusqueda.addFilterEqual("tipoCortesia", tipoCortesia);
        }

        claseServicioBusqueda.addSortAsc("tipoCortesia.desctipo");

        plwTipoCortesiaD.init(claseServicioBusqueda, tipoCortesiaDList, pagingTipoCortesiaD);

        if (tipoCortesiaDList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaTipoVentaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
